// Code generated by go-swagger; DO NOT EDIT.

package global_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateGlobalServiceParams creates a new CreateGlobalServiceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGlobalServiceParams() *CreateGlobalServiceParams {
	return &CreateGlobalServiceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGlobalServiceParamsWithTimeout creates a new CreateGlobalServiceParams object
// with the ability to set a timeout on a request.
func NewCreateGlobalServiceParamsWithTimeout(timeout time.Duration) *CreateGlobalServiceParams {
	return &CreateGlobalServiceParams{
		timeout: timeout,
	}
}

// NewCreateGlobalServiceParamsWithContext creates a new CreateGlobalServiceParams object
// with the ability to set a context for a request.
func NewCreateGlobalServiceParamsWithContext(ctx context.Context) *CreateGlobalServiceParams {
	return &CreateGlobalServiceParams{
		Context: ctx,
	}
}

// NewCreateGlobalServiceParamsWithHTTPClient creates a new CreateGlobalServiceParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGlobalServiceParamsWithHTTPClient(client *http.Client) *CreateGlobalServiceParams {
	return &CreateGlobalServiceParams{
		HTTPClient: client,
	}
}

/* CreateGlobalServiceParams contains all the parameters to send to the API endpoint
   for the create global service operation.

   Typically these are written to a http.Request.
*/
type CreateGlobalServiceParams struct {

	/* Service.

	   Payload that contains information on new service
	*/
	Service CreateGlobalServiceBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create global service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGlobalServiceParams) WithDefaults() *CreateGlobalServiceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create global service params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGlobalServiceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create global service params
func (o *CreateGlobalServiceParams) WithTimeout(timeout time.Duration) *CreateGlobalServiceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create global service params
func (o *CreateGlobalServiceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create global service params
func (o *CreateGlobalServiceParams) WithContext(ctx context.Context) *CreateGlobalServiceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create global service params
func (o *CreateGlobalServiceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create global service params
func (o *CreateGlobalServiceParams) WithHTTPClient(client *http.Client) *CreateGlobalServiceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create global service params
func (o *CreateGlobalServiceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithService adds the service to the create global service params
func (o *CreateGlobalServiceParams) WithService(service CreateGlobalServiceBody) *CreateGlobalServiceParams {
	o.SetService(service)
	return o
}

// SetService adds the service to the create global service params
func (o *CreateGlobalServiceParams) SetService(service CreateGlobalServiceBody) {
	o.Service = service
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGlobalServiceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Service); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
