// Code generated by go-swagger; DO NOT EDIT.

package logs

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewServerLogsParams creates a new ServerLogsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewServerLogsParams() *ServerLogsParams {
	return &ServerLogsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewServerLogsParamsWithTimeout creates a new ServerLogsParams object
// with the ability to set a timeout on a request.
func NewServerLogsParamsWithTimeout(timeout time.Duration) *ServerLogsParams {
	return &ServerLogsParams{
		timeout: timeout,
	}
}

// NewServerLogsParamsWithContext creates a new ServerLogsParams object
// with the ability to set a context for a request.
func NewServerLogsParamsWithContext(ctx context.Context) *ServerLogsParams {
	return &ServerLogsParams{
		Context: ctx,
	}
}

// NewServerLogsParamsWithHTTPClient creates a new ServerLogsParams object
// with the ability to set a custom HTTPClient for a request.
func NewServerLogsParamsWithHTTPClient(client *http.Client) *ServerLogsParams {
	return &ServerLogsParams{
		HTTPClient: client,
	}
}

/* ServerLogsParams contains all the parameters to send to the API endpoint
   for the server logs operation.

   Typically these are written to a http.Request.
*/
type ServerLogsParams struct {

	/* FilterField.

	   field to filter
	*/
	PageFilterField *string

	/* FilterType.

	   filter behaviour
	*/
	PageFilterType *string

	/* OrderDirection.

	   order direction
	*/
	PageOrderDirection *string

	/* OrderField.

	   field to order by
	*/
	PageOrderField *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the server logs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ServerLogsParams) WithDefaults() *ServerLogsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the server logs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ServerLogsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the server logs params
func (o *ServerLogsParams) WithTimeout(timeout time.Duration) *ServerLogsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the server logs params
func (o *ServerLogsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the server logs params
func (o *ServerLogsParams) WithContext(ctx context.Context) *ServerLogsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the server logs params
func (o *ServerLogsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the server logs params
func (o *ServerLogsParams) WithHTTPClient(client *http.Client) *ServerLogsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the server logs params
func (o *ServerLogsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPageFilterField adds the filterField to the server logs params
func (o *ServerLogsParams) WithPageFilterField(filterField *string) *ServerLogsParams {
	o.SetPageFilterField(filterField)
	return o
}

// SetPageFilterField adds the filterField to the server logs params
func (o *ServerLogsParams) SetPageFilterField(filterField *string) {
	o.PageFilterField = filterField
}

// WithPageFilterType adds the filterType to the server logs params
func (o *ServerLogsParams) WithPageFilterType(filterType *string) *ServerLogsParams {
	o.SetPageFilterType(filterType)
	return o
}

// SetPageFilterType adds the filterType to the server logs params
func (o *ServerLogsParams) SetPageFilterType(filterType *string) {
	o.PageFilterType = filterType
}

// WithPageOrderDirection adds the orderDirection to the server logs params
func (o *ServerLogsParams) WithPageOrderDirection(orderDirection *string) *ServerLogsParams {
	o.SetPageOrderDirection(orderDirection)
	return o
}

// SetPageOrderDirection adds the orderDirection to the server logs params
func (o *ServerLogsParams) SetPageOrderDirection(orderDirection *string) {
	o.PageOrderDirection = orderDirection
}

// WithPageOrderField adds the orderField to the server logs params
func (o *ServerLogsParams) WithPageOrderField(orderField *string) *ServerLogsParams {
	o.SetPageOrderField(orderField)
	return o
}

// SetPageOrderField adds the orderField to the server logs params
func (o *ServerLogsParams) SetPageOrderField(orderField *string) {
	o.PageOrderField = orderField
}

// WriteToRequest writes these params to a swagger request
func (o *ServerLogsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.PageFilterField != nil {

		// query param filter.field
		var qrFilterField string

		if o.PageFilterField != nil {
			qrFilterField = *o.PageFilterField
		}
		qFilterField := qrFilterField
		if qFilterField != "" {

			if err := r.SetQueryParam("filter.field", qFilterField); err != nil {
				return err
			}
		}
	}

	if o.PageFilterType != nil {

		// query param filter.type
		var qrFilterType string

		if o.PageFilterType != nil {
			qrFilterType = *o.PageFilterType
		}
		qFilterType := qrFilterType
		if qFilterType != "" {

			if err := r.SetQueryParam("filter.type", qFilterType); err != nil {
				return err
			}
		}
	}

	if o.PageOrderDirection != nil {

		// query param order.direction
		var qrOrderDirection string

		if o.PageOrderDirection != nil {
			qrOrderDirection = *o.PageOrderDirection
		}
		qOrderDirection := qrOrderDirection
		if qOrderDirection != "" {

			if err := r.SetQueryParam("order.direction", qOrderDirection); err != nil {
				return err
			}
		}
	}

	if o.PageOrderField != nil {

		// query param order.field
		var qrOrderField string

		if o.PageOrderField != nil {
			qrOrderField = *o.PageOrderField
		}
		qOrderField := qrOrderField
		if qOrderField != "" {

			if err := r.SetQueryParam("order.field", qOrderField); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
