// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/direktiv/direktiv/pkg/flow/ent/predicate"
	"github.com/direktiv/direktiv/pkg/flow/ent/varref"
)

// VarRefDelete is the builder for deleting a VarRef entity.
type VarRefDelete struct {
	config
	hooks    []Hook
	mutation *VarRefMutation
}

// Where appends a list predicates to the VarRefDelete builder.
func (vrd *VarRefDelete) Where(ps ...predicate.VarRef) *VarRefDelete {
	vrd.mutation.Where(ps...)
	return vrd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (vrd *VarRefDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(vrd.hooks) == 0 {
		affected, err = vrd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*VarRefMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			vrd.mutation = mutation
			affected, err = vrd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(vrd.hooks) - 1; i >= 0; i-- {
			if vrd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = vrd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, vrd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (vrd *VarRefDelete) ExecX(ctx context.Context) int {
	n, err := vrd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (vrd *VarRefDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: varref.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: varref.FieldID,
			},
		},
	}
	if ps := vrd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, vrd.driver, _spec)
}

// VarRefDeleteOne is the builder for deleting a single VarRef entity.
type VarRefDeleteOne struct {
	vrd *VarRefDelete
}

// Exec executes the deletion query.
func (vrdo *VarRefDeleteOne) Exec(ctx context.Context) error {
	n, err := vrdo.vrd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{varref.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (vrdo *VarRefDeleteOne) ExecX(ctx context.Context) {
	vrdo.vrd.ExecX(ctx)
}
